Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QWhatsThis

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QWhatsThis

All Implemented Interfaces:
  QtJambiInterface

    public final class QWhatsThis

extends QtJambiObject

The `QWhatsThis` class provides a simple description of any widget, i.e. answering the question "What's This?". "What's This?" help is part of an application's online help system, and provides users with information about the functionality and usage of a particular widget. "What's This?" help texts are typically longer and more detailed than `tooltips`, but generally provide less information than that supplied by separate help windows.

`QWhatsThis` provides a single window with an explanatory text that pops up when the user asks "What's This?". The default way for users to ask the question is to move the focus to the relevant widget and press Shift+F1. The help text appears immediately; it goes away as soon as the user does something else. (Note that if there is a shortcut for Shift+F1, this mechanism will not work.) Some dialogs provide a "?" button that users can click to enter "What's This?" mode; they then click the relevant widget to pop up the "What's This?" window. It is also possible to provide a a menu option or toolbar button to switch into "What's This?" mode.

To add "What's This?" text to a widget or an action, you simply call `QWidget::setWhatsThis()` or `QAction::setWhatsThis()`.

The text can be either rich text or plain text. If you specify a rich text formatted string, it will be rendered using the default stylesheet, making it possible to embed images in the displayed text. To be as fast as possible, the default stylesheet uses a simple method to determine whether the text can be rendered as plain text. See Qt::mightBeRichText() for details.

            newAct = new QAction(tr("New"), this);
            newAct.setShortcut(tr("Ctrl+N"));
            newAct.setStatusTip(tr("Create a new file"));
            newAct.setWhatsThis(tr("Click this option to create a new file."));

An alternative way to enter "What's This?" mode is to call `createAction()`, and add the returned `QAction` to either a menu or a tool bar. By invoking this context help action (in the picture below, the button with the arrow and question mark icon) the user switches into "What's This?" mode. If they now click on a widget the appropriate help text is shown. The mode is left when help is given or when the user presses Esc.
You can enter "What's This?" mode programmatically with `enterWhatsThisMode()`, check the mode with `inWhatsThisMode()`, and return to normal mode with `leaveWhatsThisMode()`.

If you want to control the "What's This?" behavior of a widget manually see `Qt::WA_CustomWhatsThis` .

It is also possible to show different help texts for different regions of a widget, by using a `QHelpEvent` of type `QEvent::WhatsThis` . Intercept the help event in your widget's `QWidget::event()` function and call `QWhatsThis::showText()` with the text you want to display for the position specified in `QHelpEvent::pos()`. If the text is rich text and the user clicks on a link, the widget also receives a `QWhatsThisClickedEvent` with the link's reference as `QWhatsThisClickedEvent::href()`. If a `QWhatsThisClickedEvent` is handled (i.e. `QWidget::event()` returns true), the help window remains visible. Call `QWhatsThis::hideText()` to hide it explicitly.

See also:
  `QToolTip`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Method Summary
`static QAction` | `createAction()` Returns a ready-made `QAction`, used to invoke "What's This?" context help, with the given `parent`.
`static QAction` | `createAction(QObject parent)` Returns a ready-made `QAction`, used to invoke "What's This?" context help, with the given `parent`.
`static void` | `enterWhatsThisMode()` This function switches the user interface into "What's This?" mode.
`static void` | `hideText()` If a "What's This?" window is showing, this destroys it.
`static boolean` | `inWhatsThisMode()` Returns true if the user interface is in "What's This?" mode; otherwise returns false.
`static void` | `leaveWhatsThisMode()` If the user interface is in "What's This?" mode, this function switches back to normal mode; otherwise it does nothing.
`static void` | `showText(QPoint pos, java.lang.String text)` Shows `text` as a "What's This?" window, at global position `pos`.
`static void` | `showText(QPoint pos, java.lang.String text, QWidget w)` Shows `text` as a "What's This?" window, at global position `pos`.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Method Detail

### createAction

    public static QAction createAction()

  Returns a ready-made `QAction`, used to invoke "What's This?" context help, with the given `parent`.

  The returned `QAction` provides a convenient way to let users enter "What's This?" mode.

### createAction

    public static QAction createAction(QObject parent)

  Returns a ready-made `QAction`, used to invoke "What's This?" context help, with the given `parent`.

  The returned `QAction` provides a convenient way to let users enter "What's This?" mode.

### enterWhatsThisMode

    public static void enterWhatsThisMode()

  This function switches the user interface into "What's This?" mode. The user interface can be switched back into normal mode by the user (e.g. by them clicking or pressing Esc), or programmatically by calling `leaveWhatsThisMode()`.

  When entering "What's This?" mode, a `QEvent` of type Qt::EnterWhatsThisMode is sent to all toplevel widgets.

See also:
  `inWhatsThisMode()`, and `leaveWhatsThisMode()`.

### hideText

    public static void hideText()

  If a "What's This?" window is showing, this destroys it.

See also:
  `showText()`.

### inWhatsThisMode

    public static boolean inWhatsThisMode()

  Returns true if the user interface is in "What's This?" mode; otherwise returns false.

See also:
  `enterWhatsThisMode()`.

### leaveWhatsThisMode

    public static void leaveWhatsThisMode()

  If the user interface is in "What's This?" mode, this function switches back to normal mode; otherwise it does nothing.

  When leaving "What's This?" mode, a `QEvent` of type Qt::LeaveWhatsThisMode is sent to all toplevel widgets.

See also:
  `enterWhatsThisMode()`, and `inWhatsThisMode()`.

### showText

    public static void showText(QPoint pos,
                                java.lang.String text)

  Shows `text` as a "What's This?" window, at global position `pos`. The optional widget argument, `w`, is used to determine the appropriate screen on multi-head systems.

See also:
  `hideText()`.

### showText

    public static void showText(QPoint pos,
                                java.lang.String text,
                                QWidget w)

  Shows `text` as a "What's This?" window, at global position `pos`. The optional widget argument, `w`, is used to determine the appropriate screen on multi-head systems.

See also:
  `hideText()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD